/***************************************************************************
                          dictactions.h  -  description
                             -------------------
    begin                : . .. 22 20:37:33 ICT 2002
    copyright            : (C) 2002 by Thanomsub Noppaburana
    email                : donga_n@yahoo.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef __DICTACTIONS_H__
#define __DICTACTIONS_H__

#include <qguardedptr.h>
#include <qptrlist.h>

#include <kaction.h>
#include <kglobalsettings.h>

class KComboBox;
class QLabel;
class QPushButton;

class CActLabel : public KAction
{
  Q_OBJECT

  public:
    CActLabel(const QString &text, QObject *parent = 0, const char *name = 0);
    ~CActLabel();

    virtual int plug(QWidget *widget, int index = -1);
    virtual void unplug(QWidget *widget );
    
    void setBuddy(QWidget *buddy);

  private:
    QGuardedPtr<QLabel> labelPtr;
};


class CActComboBox : public KAction
{
  Q_OBJECT

  public:
    CActComboBox(const QString& text, QObject* parent,
                 const char* name, bool editable, bool autoSized);
    ~CActComboBox();

    virtual int plug( QWidget *w, int index = -1 );
    virtual void unplug( QWidget *w );

    QWidget* widget();
    void setFocus();
    QString currentText();
    void setEditText(const QString &s);
    void setCurrentItem(int index);
    void clearEdit();
    void clear();
    void setList(QStringList items);

  signals:
    void activated(int);
    void activated(const QString&);

  private slots:
    void slotComboActivated(int);
    void slotComboActivated(const QString&);

  private:
    QGuardedPtr<KComboBox> comboPtr;
    bool flagEditable, flagAutoSized;
    KGlobalSettings::Completion compMode;
};

class CActButton : public KAction
{
  Q_OBJECT

  public:
    CActButton(const QString& text, QObject* receiver,
               const char* slot, QObject* parent, const char* name);
    ~CActButton();

    virtual int plug( QWidget *w, int index = -1 );
    virtual void unplug( QWidget *w );

    int widthHint();
    void setWidth(int width);

  private:
    QGuardedPtr<QPushButton> buttonPtr;
};

#endif
