/***************************************************************************
                          dictdb.h  -  description
                             -------------------
    begin                : . .. 21 2002
    copyright            : (C) 2002 by Thanomsub Noppaburana
    email                : donga_n@yahoo.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef __DICTDB_H__
#define __DICTDB_H__

#define	DICTDATABASE	"dictdata.db"

//const char* DICTDATABASENAME = "dictdata.db";

#include <string>
using namespace std;

class Db;
class Dbc;
class Dbt;


class CDictRecord
{
  public:
    CDictRecord() { word = ""; meaning = ""; }
    CDictRecord(char *wrd, char *mean) { word=wrd; meaning=mean; };
    CDictRecord(string wrd, string mean) { word=wrd; meaning=mean; };
    CDictRecord(CDictRecord &d) { word = d.word; meaning = d.meaning; };
    string word;
    string meaning;
};


class CDictData
{
  public:
    CDictData(const char *dbFile = 0);
    ~CDictData();

    enum searchMode { smMatchOnly = 0, smMatchRange = 1 };
    enum searchResult { srcFound = true, srcNotfound = false };
    
    void setMode(int mode = smMatchRange);
    CDictRecord *dictRecord();
    int recordsCount();
    bool searchDict(char *);
    bool searchDict(const char *);
    CDictRecord *nextRecord();

    char *Keyword() const;
    char *Meaning() const;
    
  private:
    CDictRecord *dictResult;
    Db          *dbPtr;
    Dbc         *dbCursorPtr;
    Dbt         *currentKey;
    Dbt         *currentData;
    
    int         searchMode;
};

#endif
