/***************************************************************************
                          dictengine.h  -  description
                             -------------------
    begin                : . .. 22 2002
    copyright            : (C) 2002 by Thanomsub Noppaburana
    email                : donga_n@yahoo.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef __DICTENGINE_H__
#define __DICTENGINE_H__

class QObject;
class CDictData;
class CDictRecord;


class CDictEngine : public QObject
{
  Q_OBJECT

  public:
    CDictEngine();
    ~CDictEngine();

    int recordsCount();
    QString queryText();
    QString keyword();
    QString meaning();

    void setMaxRelateWords(const int);
    QStringList &getRelateWordList();
    bool searchKeyword(const char *keyword);
    bool searchKeyword(const QString &keyword);
    bool searchWithNoSignal(const char *keyword);
    bool searchWithNoSignal(const QString &keyword);

    void goNextRecord();

    QString pharseString(QString &str);
    QString generateHTML(QString &str);

  signals:
    void resultReady(const QString &result);
    void searchComplete();
    void started();
    void stoped();

  private:
    QString convertCodec(const QString &str);
  
    CDictData   *dictDB;
    CDictRecord *dictRec;
    QString     charset;
    QString     _queryText;
    int         maxRelateWord;
};

extern CDictEngine *dictEngine;

#endif
