/***************************************************************************
                          dictresview.h  -  description
                             -------------------
    begin                : . .. 25 2002
    copyright            : (C) 2002 by Thanomsub Noppaburana
    email                : donga_n@yahoo.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef __DICTRESVIEW_H__
#define __DICTRESVIEW_H__

#include <qvbox.h>
#include <qlabel.h>

#include <khtml_part.h>


QString getShortString(QString str,unsigned int length);

class KURL;
class KTempFile;
class KPopupMenu;
class KToolBarPopupAction;
class CActComboBox;


class CBrowseData
{
  public:
    CBrowseData(const QString &NhtmlStr, const QString &NwordRequest);
    QString htmlStr, wordRequest;
    int xPos, yPos;
};


class CHTMLPart : public KHTMLPart
{
  Q_OBJECT

  public:
    CHTMLPart(QWidget *parent = 0, const char *name = 0);
    ~CHTMLPart();

  signals:
    void middleButtonClicked();

  protected:
    virtual void khtmlMouseReleaseEvent(khtml::MouseReleaseEvent *event);
};



class CResultView : public QVBox
{
  Q_OBJECT

  public:
    CResultView(QWidget *parent = 0);
    ~CResultView();

    void setActions(KToolBarPopupAction* actBack, KToolBarPopupAction* actForward, CActComboBox* actKeyCombo);
    void begin(const KURL &url = KURL(), int xOffset = 0, int yOffset = 0);
    void write(const char *);
    void write(const QString &);
    void end();
    bool canBrowseBack();
    bool canBrowseForward();
    void generateHeader();
    void optionChanged();
    
  public slots:
    void slotPrintResult();
    void slotCopySelection();
    void slotSelectAll();
    void slotBrowseBack();
    void slotBrowseForward();
    void slotShowFindDialog();
    //void slotFindWordOnClipboard();

  protected slots:
    void slotResultReady(const QString &result);
    void slotBuildPopupMenu(const QString &, const QPoint &);
    void slotEnableAction(const char *, bool);
    void slotBrowseBack(int);
    void slotBrowseForward(int);
    void slotSaveCurrentPos();
    void slotUpdateBrowseActions();

  signals:
    void enableCopy(bool selected);
    void enablePrint();
    void renderComplete(QString &);
      
  private:
    void showResult();
    
    KPopupMenu            *popupMenu;
    QString               popupLink,popupSelect;
    
    CHTMLPart             *htmlView;
    QString               HTMLheader;
    KToolBarPopupAction   *actBackBTN, *actForwardBTN;
    CActComboBox          *actKeyCMB;
    QPtrList<CBrowseData> browseList;
    unsigned int          browsePos;  // position in browseList
};


#endif
