/***************************************************************************
                          dictsystemtray.h  -  description
                             -------------------
    begin                : . .. 27 2002
    copyright            : (C) 2002 by Thanomsub Noppaburana
    email                : donga_n@yahoo.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef __DICTSYSTEMTRAY_H__
#define __DICTSYSTEMTRAY_H__

#include <kglobalaccel.h>
#include <ksystemtray.h>

class KPopupMenu;
class CResultView;

class CDictSystemTray: public KSystemTray
{
  Q_OBJECT

  public:
    CDictSystemTray(QWidget* parent = 0, const char* name  = 0);
    ~CDictSystemTray();

    void assignResultView(CResultView *);
    KPopupMenu *menu() { return trayMenu; }
    KGlobalAccel *globalKeys;

  protected:
    void mousePressEvent(QMouseEvent *);
    void mouseReleaseEvent(QMouseEvent *);

  protected slots:
    void switchRestore();
    void prepareMenu();
    void confirmQuit();
    void slotConfig();
    void slotToggleWatchClipboard();
    void slotSearchOnClipboard();
    void slotResultReady(QString &);

  private:
    KPopupMenu *trayMenu;
    int restoreItem;
    int watchItem;
};

#endif
