/***************************************************************************
                          dictwordlist.cpp  -  description
                             -------------------
    begin                : . .. 26 2002
    copyright            : (C) 2002 by Thanomsub Noppaburana
    email                : donga_n@yahoo.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include <qclipboard.h>
#include <qtimer.h>

#include <kcursor.h>
#include <kpopupmenu.h>
#include <kmessagebox.h>
#include <klocale.h>
#include <khtml_events.h>
#include <khtmlview.h>
#include <kapplication.h>
#include <kiconloader.h>

#include "dictengine.h"
#include "dictactions.h"
#include "dictwordlist.h"


// ***************************************************************
//                   Class CDictWordList Implementation
// ***************************************************************

CWordList::CWordList(QWidget *parent)
  : QVBox(parent)
{
  wordLabel = new QLabel(this);
  wordLabel->setPaletteBackgroundColor(QColor("Magenta"));
  wordLabel->setFrameStyle(QFrame::Box | QFrame::Sunken);
  wordLabel->setText(i18n("Word lists"));
  wordLabel->setAlignment(Qt::AlignHCenter | Qt::AlignVCenter);

  wordListBox = new QListBox(this);
  connect(wordListBox, SIGNAL(highlighted(const QString &)), SLOT(slotHighlighted(const QString &)));
}


CWordList::~CWordList()
{
}


void CWordList::insertStringList(const QStringList &list, int index)
{
  wordListBox->insertStringList(list, index);
}


void CWordList::clear()
{
  wordListBox->clear();
}


void CWordList::setCurrentItem(int index)
{
  wordListBox->setCurrentItem(index);
}


void CWordList::slotHighlighted(const QString &keyword)
{
  emit(highlighted(keyword));
}


//-----------------------
#include "dictwordlist.moc"
