/***************************************************************************
                          kdictthai.h  -  description
                             -------------------
    begin                : . .. 22 20:37:33 ICT 2002
    copyright            : (C) 2002 by Thanomsub Noppaburana
    email                : donga_n@yahoo.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef __KDICTTHAI_H__
#define __KDICTTHAI_H__

#include <kaction.h>
#include <kmainwindow.h>

#include "dcopinterface.h"


class QSplitter;
class KToggleAction;
class KToolBarPopupAction;

class CDictSystemTray;
class COptionDialog;
class CActLabel;
class CActComboBox;
class CResultView;
class CWordList;
class CWatchClipboard;


class KDictThai : public KMainWindow, virtual public KDictThaiIface
{
  Q_OBJECT
  
  public:
    KDictThai(QWidget* parent=0, const char *name=0,
              WFlags f = WType_TopLevel | WDestructiveClose);
    ~KDictThai();

    void saveSettings();

    // ** DCOP Interface ** //
    void quit();
    void makeActiveWindow();

  protected:
    bool queryClose();

  public slots:
    void slotAssignKeyword(const QString&);
    void slotFindKeyword();
    void slotFindWordOnClipboard();
    void slotShowOptionDialog();
    void slotHideOptionDialog();
    void slotClipboardChanged(QString);
    void slotToggleWatchClipboard();

  protected slots:
    void slotToggleToolbar();
    void slotToggleStatusbar();
    void slotToggleWordList();
    void slotToggleDockIcon();
    void slotConfigKeys();
    void slotConfigToolbar();
    void slotHistoryClicked();
    void slotOptionChanged();
    void slotEnableCopy(bool);
    void slotEnablePrint();
    void slotClearInput();
    void slotClearWordHistory();
    void slotSearchComplete();
    void slotHighlighted(const QString &);
          
  private:
    void setupActions();
    void setupStatusBar();
    void setupWordList();
    void recreateGUI();
    void addWordToHistory();
    void buildHistoryMenu();

    CWatchClipboard *watchCliboard;
    QString currentKeyword;
    CDictSystemTray *dock;
    CResultView   *resultView;
    KAction       *actPrint, *actCopy;
    KToggleAction *actToggleToolbar;
    KToggleAction *actToggleStatusbar;
    KToggleAction *actToggleWordList;
    KToggleAction *actToggleDock;
    KToggleAction *actToggleWatch;
    KToolBarPopupAction *actBrowseBack, *actBrowseForward;
    QPtrList<KAction> historyList;
    QSplitter     *splitter;
    CWordList     *wordList;
    COptionDialog *optionDialog;
    CActLabel     *actKeyLB;
    CActComboBox  *actKeyCMB;
};

#endif
