/***************************************************************************
                          watchclipboard.cpp  -  description
                             -------------------
    begin                : . .. 26 2002
    copyright            : (C) 2002 by Thanomsub Noppaburana
    email                : donga_n@yahoo.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

 #include <qtimer.h>
 #include <qclipboard.h>
 
 #include <kapplication.h>

 #include "watchclipboard.h"

 // ***************************************************************
//             Class CWatchClipboard Implementation
// ***************************************************************

CWatchClipboard::CWatchClipboard()
  : QObject(), watchTimer(NULL), _interval(1000), lastContent("")
{
}


CWatchClipboard::~CWatchClipboard()
{
  stopWatch();
}


void CWatchClipboard::setInterval(int msec)
{
  if (_interval != msec) {
    _interval = msec;
    if (watchTimer != NULL) watchTimer->changeInterval(_interval);
  }
}


void CWatchClipboard::startWatch()
{
  stopWatch();
  watchTimer = new QTimer(this, "watchTimer");
  connect(watchTimer, SIGNAL(timeout()), this, SLOT(slotOnTimer()));
  watchTimer->start(_interval, false);
}


void CWatchClipboard::stopWatch()
{
  if (watchTimer != NULL) {
    watchTimer->stop();
    delete watchTimer;
    watchTimer = NULL;
  }
}


QString CWatchClipboard::getClipboardContent()
{
  kapp->clipboard()->setSelectionMode(true);
  QString text = kapp->clipboard()->text();
  if (text.isEmpty()) {
    kapp->clipboard()->setSelectionMode(false);
    text = kapp->clipboard()->text();
  }
  return text;
}


// ********* CWatchClipboard Slot implement ********** //

void CWatchClipboard::slotOnTimer()
{
  QString content = getClipboardContent();
  if (lastContent != content) {
    lastContent = content;
    emit(clipboardChanged(content));
  }
}
