/***************************************************************************
                          watchclipboard.h  -  description
                             -------------------
    begin                : . .. 26 2002
    copyright            : (C) 2002 by Thanomsub Noppaburana
    email                : donga_n@yahoo.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef __WATCHCLIPBOARD_H__
#define __WATCHCLIPBOARD_H__

#include <qobject.h>

class QTimer;

class CWatchClipboard : public QObject
{
  Q_OBJECT
  
  public:
    CWatchClipboard();
    ~CWatchClipboard();

    void setInterval(int msec);
    int getInterval() { return _interval; };
    QString getClipboardContent();

    void startWatch();
    void stopWatch();

  signals:
    void clipboardChanged(QString);

  public slots:
    void slotOnTimer();

  private:
    QTimer  *watchTimer;
    int      _interval;
    QString  lastContent;
};

#endif
